// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/EnergyStorageType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__SIZE_BITS = 7
};

/// Constant 'BIT_INDEX_HYDROGEN_STORAGE'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_HYDROGEN_STORAGE = 0
};

/// Constant 'BIT_INDEX_ELECTRIC_ENERGY_STORAGE'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_ELECTRIC_ENERGY_STORAGE = 1
};

/// Constant 'BIT_INDEX_LIQUID_PROPANE_GAS'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_LIQUID_PROPANE_GAS = 2
};

/// Constant 'BIT_INDEX_COMPRESSED_NATURAL_GAS'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_COMPRESSED_NATURAL_GAS = 3
};

/// Constant 'BIT_INDEX_DIESEL'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_DIESEL = 4
};

/// Constant 'BIT_INDEX_GASOLINE'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_GASOLINE = 5
};

/// Constant 'BIT_INDEX_AMMONIA'.
enum
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__BIT_INDEX_AMMONIA = 6
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/EnergyStorageType in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__EnergyStorageType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicated the type of energy being used and stored in vehicle.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 - `hydrogenStorage`       - when hydrogen is being used and stored in vehicle,
  ///  * - 1 - `electricEnergyStorage` - when electric energy is being used and stored in vehicle,
  ///  * - 2 - `liquidPropaneGas`      - when liquid Propane Gas (LPG) is being used and stored in vehicle,
  ///  * - 3 - `compressedNaturalGas ` - when compressedNaturalGas (CNG) is being used and stored in vehicle,
  ///  * - 4 - `diesel`                - when diesel is being used and stored in vehicle,
  ///  * - 5 - `gasoline`              - when gasoline is being used and stored in vehicle,
  ///  * - 6 - `ammonia`               - when ammonia is being used and stored in vehicle.
  ///  *
  ///  * - Otherwise, the corresponding bit shall be set to `0`.
  ///  *
  ///  * @category: Vehicle information
  ///  * @revision: editorial revision in V2.1.1
  ///  */
  /// EnergyStorageType ::= BIT STRING {
  ///     hydrogenStorage       (0),
  ///     electricEnergyStorage (1),
  ///     liquidPropaneGas      (2),
  ///     compressedNaturalGas  (3),
  ///     diesel                (4),
  ///     gasoline              (5),
  ///     ammonia               (6)
  /// }(SIZE(7))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_denm_ts_msgs__msg__EnergyStorageType;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__EnergyStorageType.
typedef struct etsi_its_denm_ts_msgs__msg__EnergyStorageType__Sequence
{
  etsi_its_denm_ts_msgs__msg__EnergyStorageType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__EnergyStorageType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_H_
