// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/LanePositionOptions.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_SIMPLELANE_POSITION'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__CHOICE_SIMPLELANE_POSITION = 0
};

/// Constant 'CHOICE_SIMPLE_LANE_TYPE'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__CHOICE_SIMPLE_LANE_TYPE = 1
};

/// Constant 'CHOICE_DETAILEDLANE_POSITION'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__CHOICE_DETAILEDLANE_POSITION = 2
};

/// Constant 'CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS = 3
};

/// Constant 'CHOICE_TRAFFIC_ISLAND_POSITION'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions__CHOICE_TRAFFIC_ISLAND_POSITION = 4
};

// Include directives for member types
// Member 'simplelane_position'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__struct.h"
// Member 'simple_lane_type'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_type__struct.h"
// Member 'detailedlane_position'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_and_type__struct.h"
// Member 'lane_position_with_lateral_details'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_with_lateral_details__struct.h"
// Member 'traffic_island_position'
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_island_position__struct.h"

/// Struct defined in msg/LanePositionOptions in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__LanePositionOptions
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a set of options to describe a lane position and is the second level DF to represent a lane position. The top-level DFs are @ref GeneralizedLanePosition or @ref OccupiedLanesWithConfidence.
  ///  * A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
  ///  *
  ///  * The following options are available:
  ///  *
  ///  * @field simplelanePosition: a single lane position without any additional context information.
  ///  *
  ///  * @field simpleLaneType: a lane type, to be used when the lane position is unknown but the type of lane is known. This can be used in scenarios where a certain confidence about the used lane type is given
  ///  * but no or limited knowledge about the absolute lane number is available. For example, a cyclist on a cycle-lane or vehicles on a specific lane that is unique for the part of the road (e.g. a bus lane).
  ///  *
  ///  * @field detailedlanePosition: a single lane position with additional lane details.
  ///  *
  ///  * @field lanePositionWithLateralDetails: a single lane position with additional details and the lateral position within the lane.
  ///  *
  ///  * @field trafficIslandPosition: a position on a traffic island, i.e. between two lanes.
  ///  *
  ///  * @category: Road Topology information
  ///  * @revision: Created in V2.2.1 from the DF GeneralizedLanePosition of V2.1.1.
  ///  */
  /// LanePositionOptions ::= CHOICE {
  ///     simplelanePosition                   LanePosition,
  ///     simpleLaneType                       LaneType,
  ///     detailedlanePosition                 LanePositionAndType,
  ///     lanePositionWithLateralDetails       LanePositionWithLateralDetails,
  ///     trafficIslandPosition                TrafficIslandPosition,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_denm_ts_msgs__msg__LanePosition simplelane_position;
  etsi_its_denm_ts_msgs__msg__LaneType simple_lane_type;
  etsi_its_denm_ts_msgs__msg__LanePositionAndType detailedlane_position;
  etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails lane_position_with_lateral_details;
  etsi_its_denm_ts_msgs__msg__TrafficIslandPosition traffic_island_position;
} etsi_its_denm_ts_msgs__msg__LanePositionOptions;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__LanePositionOptions.
typedef struct etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence
{
  etsi_its_denm_ts_msgs__msg__LanePositionOptions * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__LanePositionOptions__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_H_
