// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationSection.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'road_section_definition'
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__struct.h"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__struct.h"
// Member 'lane_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/basic_lane_configuration__struct.h"
// Member 'mapem_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_configuration__struct.h"

/// Struct defined in msg/RoadConfigurationSection in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__RoadConfigurationSection
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides configuration information about a road section.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field roadSectionDefinition: the topological definition of the road section for which the information in the other components applies throughout its entire length.
  ///  *
  ///  * @field roadType: the optional type of road on which the section is located.
  ///  *
  ///  * @field laneConfiguration: the optional configuration of the road section in terms of basic information per lane.
  ///  *
  ///  * @field mapemConfiguration: the optional configuration of the road section in terms of MAPEM lanes or connections.
  ///  *
  ///  * @category: Road topology information
  ///  * @revision: Created in V2.2.1
  /// */
  /// RoadConfigurationSection ::= SEQUENCE {
  ///   roadSectionDefinition  RoadSectionDefinition,
  ///   roadType               RoadType OPTIONAL,
  ///   laneConfiguration      BasicLaneConfiguration OPTIONAL,
  ///   mapemConfiguration     MapemConfiguration OPTIONAL,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__RoadSectionDefinition road_section_definition;
  etsi_its_denm_ts_msgs__msg__RoadType road_type;
  bool road_type_is_present;
  etsi_its_denm_ts_msgs__msg__BasicLaneConfiguration lane_configuration;
  bool lane_configuration_is_present;
  etsi_its_denm_ts_msgs__msg__MapemConfiguration mapem_configuration;
  bool mapem_configuration_is_present;
} etsi_its_denm_ts_msgs__msg__RoadConfigurationSection;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__RoadConfigurationSection.
typedef struct etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence
{
  etsi_its_denm_ts_msgs__msg__RoadConfigurationSection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__RoadConfigurationSection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_H_
