// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/RoadWorksContainerExtended.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_denm_ts_msgs/msg/detail/light_bar_siren_in_use__struct.h"
// Member 'closed_lanes'
#include "etsi_its_denm_ts_msgs/msg/detail/closed_lanes__struct.h"
// Member 'restriction'
#include "etsi_its_denm_ts_msgs/msg/detail/restricted_types__struct.h"
// Member 'speed_limit'
#include "etsi_its_denm_ts_msgs/msg/detail/speed_limit__struct.h"
// Member 'incident_indication'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__struct.h"
// Member 'recommended_path'
#include "etsi_its_denm_ts_msgs/msg/detail/itinerary_path__struct.h"
// Member 'starting_point_speed_limit'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_reference_position__struct.h"
// Member 'traffic_flow_rule'
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_rule__struct.h"
// Member 'reference_denms'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id_list__struct.h"

/// Struct defined in msg/RoadWorksContainerExtended in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type contains detailed information of a roadwork zone and specific access conditions.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field lightBarSirenInUse: optionally indicates whether a roadwork vehicle has switched on the light bar or siren.
  ///  * It is used when the roadwork involves a specific roadwork vehicle
  ///  *
  ///  * @field closedLanes: optionally indicates whether the roadwork has caused the closure of one or several driving lanes.
  ///  * Optionally, it may indicate whether a hard shoulder lane is closed to traffic or can be used for specific usage (e.g. for stopping).
  ///  *
  ///  * @field restriction: the optional type(s) of vehicles that are restricted to access the road work zone.
  ///  * More than one vehicle types may be provided by this component if the restriction apply to multiple vehicle types.
  ///  *
  ///  * @field speedLimit: the optional speed limitation applied to the roadwork zone.
  ///  *
  ///  * @field incidentIndication: the optional incident related to the roadworks to provide additional information of the roadworks zone.
  ///  *
  ///  * @field recommendedPath: the optional recommended itinerary in order to contour the roadworks zone. If present, a recommended path
  ///  * shall be a list of path points in the order from the starting point closest to the roadworks zone to the end point of the recommended path.
  ///  *
  ///  * @field startingPointSpeedLimit: the optional effective starting position of a speed limit being applied to the roadwork zone,
  ///  * with respect to the component eventPosition on the Management Container.
  ///  * This component shall be present if the speed limit is applied at a certain distance prior to the roadwork zone starting position.
  ///  *
  ///  * @field trafficFlowRule: optionally indicates the side of the road to which the traffic should flow around a roadwork.
  ///  *
  ///  * @field referenceDenms: an optional sequence of actionIds for different DENMs that describe the same event.
  ///  * If it is available, it indicates the actionIds of all other DENMs describing this event.
  ///  *
  /// */
  /// RoadWorksContainerExtended ::= SEQUENCE {
  ///     lightBarSirenInUse      LightBarSirenInUse OPTIONAL,
  ///     closedLanes             ClosedLanes OPTIONAL,
  ///     restriction             RestrictedTypes OPTIONAL,
  ///     speedLimit              SpeedLimit OPTIONAL,
  ///     incidentIndication      CauseCodeV2 OPTIONAL,
  ///     recommendedPath         ItineraryPath OPTIONAL,
  ///     startingPointSpeedLimit DeltaReferencePosition OPTIONAL,
  ///     trafficFlowRule         TrafficRule OPTIONAL,
  ///     referenceDenms          ActionIdList OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__LightBarSirenInUse light_bar_siren_in_use;
  bool light_bar_siren_in_use_is_present;
  etsi_its_denm_ts_msgs__msg__ClosedLanes closed_lanes;
  bool closed_lanes_is_present;
  etsi_its_denm_ts_msgs__msg__RestrictedTypes restriction;
  bool restriction_is_present;
  etsi_its_denm_ts_msgs__msg__SpeedLimit speed_limit;
  bool speed_limit_is_present;
  etsi_its_denm_ts_msgs__msg__CauseCodeV2 incident_indication;
  bool incident_indication_is_present;
  etsi_its_denm_ts_msgs__msg__ItineraryPath recommended_path;
  bool recommended_path_is_present;
  etsi_its_denm_ts_msgs__msg__DeltaReferencePosition starting_point_speed_limit;
  bool starting_point_speed_limit_is_present;
  etsi_its_denm_ts_msgs__msg__TrafficRule traffic_flow_rule;
  bool traffic_flow_rule_is_present;
  etsi_its_denm_ts_msgs__msg__ActionIdList reference_denms;
  bool reference_denms_is_present;
} etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended.
typedef struct etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended__Sequence
{
  etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_
