// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/TrafficDirection.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'ALL_TRAFFIC_DIRECTIONS'.
enum
{
  etsi_its_denm_ts_msgs__msg__TrafficDirection__ALL_TRAFFIC_DIRECTIONS = 0
};

/// Constant 'SAME_AS_REFERENCE_DIRECTION_UPSTREAM_OF_REFERENCE_POSITION'.
enum
{
  etsi_its_denm_ts_msgs__msg__TrafficDirection__SAME_AS_REFERENCE_DIRECTION_UPSTREAM_OF_REFERENCE_POSITION = 1
};

/// Constant 'SAME_AS_REFERENCE_DIRECTION_DOWNSTREAM_OF_REFERENCE_POSITION'.
enum
{
  etsi_its_denm_ts_msgs__msg__TrafficDirection__SAME_AS_REFERENCE_DIRECTION_DOWNSTREAM_OF_REFERENCE_POSITION = 2
};

/// Constant 'OPPOSITE_TO_REFERENCE_DIRECTION'.
enum
{
  etsi_its_denm_ts_msgs__msg__TrafficDirection__OPPOSITE_TO_REFERENCE_DIRECTION = 3
};

/// Struct defined in msg/TrafficDirection in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__TrafficDirection
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates a direction of traffic with respect to a reference direction, and a portion of that traffic with respect to a reference position.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `allTrafficDirections`                                    - for all directions of traffic,
  ///  * - 1 `sameAsReferenceDirection-upstreamOfReferencePosition`    - for the direction of traffic according to the reference direction, and the portion of traffic upstream of the reference position,
  ///  * - 2 `sameAsReferenceDirection-downstreamOfReferencePosition`  - for the direction of traffic according to the reference direction, and the portion of traffic downstream of the reference position,
  ///  * - 3 `oppositeToReferenceDirection`                            - for the direction of traffic opposite to the reference direction.
  ///  *
  ///  * @note: Upstream traffic corresponds to the incoming traffic towards the event position, and downstream traffic to the departing traffic away from the event position.
  ///  * @category: GeoReference information
  ///  * @revision: Created in V2.1.1 from RelevanceTrafficDirection, description and naming of values changed in V2.2.1
  ///  *
  ///  */
  ///  TrafficDirection ::= ENUMERATED {
  ///     allTrafficDirections(0),
  ///     sameAsReferenceDirection-upstreamOfReferencePosition(1),
  ///     sameAsReferenceDirection-downstreamOfReferencePosition(2),
  ///     oppositeToReferenceDirection(3)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__TrafficDirection;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__TrafficDirection.
typedef struct etsi_its_denm_ts_msgs__msg__TrafficDirection__Sequence
{
  etsi_its_denm_ts_msgs__msg__TrafficDirection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__TrafficDirection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_
